<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.7.0/jquery.min.js"></script>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <title>ListContact</title>
</head>

<body onload="onPageLoading()">
    <div class="container-fluid">
        <div class="text-center">
            <h3>DANH SÁCH LIÊN HỆ</h3>
        </div>
        <table id="table-contact" class="table table-striped table-bordered table-primary">
            <thead>
                <tr>
                    <th scope="col">STT</th>
                    <th scope="col">Name</th>
                    <th scope="col">Email</th>
                    <th scope="col">Message</th>
                    <th scope="col">Ngày liên hệ</th>
                    <th scope="col">Action</th>
                </tr>
            </thead>
            <tbody>

            </tbody>
    </div>
</body>
<script>
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_CREATE_OK = 201; // status 201 là tạo mới thành công
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL = "https://62442d9d3da3ac772b0c50eb.mockapi.io/api/v1/";


    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */


    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
        var vXmlHttpContact = new XMLHttpRequest();
        callApiToGetContactList(vXmlHttpContact);
        vXmlHttpContact.onreadystatechange = function () {
            if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                console.log(vXmlHttpContact.responseText); // ghi response text ra console.log
                displayContactListIntoTable(vXmlHttpContact)


            }
        }
    }
    function onBtnUpdateClick(paramUpdateButton) {
        console.log("id: " + paramUpdateButton.getAttribute("id"))
        const vURL_CONTACT_DETAIL = "contactDetail.html"
        var vId = paramUpdateButton.getAttribute("id");
        var vUrlOpenPage = vURL_CONTACT_DETAIL + "?id=" + vId;
        window.location.href = vUrlOpenPage
    }
    function onBtnDeleteClick(paramDeleteButton) {
        console.log("id: " + paramDeleteButton.getAttribute("id"))
        var vThongBao = "Bạn có chắc chắn muốn xóa liên hệ này!";
        if (confirm(vThongBao) == false) {
            console.log("Hên quá không bị xóa")
        }else{
            console.log("xóa nè")
            dsada
        }
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //hàm gọi API lấy list contact:
    function callApiToGetContactList(paramXmlHttpContact) {
        var vAPI_URL = gBASE_URL + "/contacts";
        paramXmlHttpContact.open("GET", vAPI_URL, true);
        paramXmlHttpContact.send();
    }
    //hàm hiển thị danh sách ra table:
    function displayContactListIntoTable(paramXmlHttpContact) {
        var vContactListObj = JSON.parse(paramXmlHttpContact.responseText)
        var vTableContact = document.getElementById("table-contact");
        var vTbodyTable = vTableContact.getElementsByTagName("tbody")[0];
        
        for (var bI = 0; bI < vContactListObj.length; bI++) {
            var bNewRow = vTbodyTable.insertRow(-1);
            var bSttCell = bNewRow.insertCell(0);
            var bNameCell = bNewRow.insertCell(1);
            var bEmailCell = bNewRow.insertCell(2);
            var bMessageCell = bNewRow.insertCell(3);
            var bDateCell = bNewRow.insertCell(4);
            var bActionCell = bNewRow.insertCell(5);
            bSttCell.innerHTML = bI + 1;
            bNameCell.innerHTML = vContactListObj[bI].name;
            bEmailCell.innerHTML = vContactListObj[bI].name;
            bMessageCell.innerHTML = vContactListObj[bI].email;
            bDateCell.innerHTML = vContactListObj[bI].message;
            
            var vButtonUpdate = document.createElement("button");
            vButtonUpdate.innerHTML = "Sửa"
            vButtonUpdate.className = "btn btn-success mr-1"
            vButtonUpdate.setAttribute("onclick", "onBtnUpdateClick(this)")
            vButtonUpdate.setAttribute("id", vContactListObj[bI].id)
            bActionCell.appendChild(vButtonUpdate)

            var vButtonDelete = document.createElement("button");
            vButtonDelete.innerHTML = "Xóa"
            vButtonDelete.className = "btn btn-danger"
            vButtonDelete.setAttribute("onclick", "onBtnDeleteClick(this)")
            vButtonDelete.setAttribute("id", vContactListObj[bI].id)
            bActionCell.appendChild(vButtonDelete)
        }
    }

  


</script>

</html>